'$INCLUDE: 'smada.bi'

DEFINT A-Y
SUB MakeDimRainfall (r AS RainfallType)
'REDIM a$(5)
DIM i                   AS INTEGER
DIM peakstep            AS INTEGER
DIM a                   AS SINGLE
DIM PeakPrecip          AS SINGLE
DIM DimTime             AS SINGLE
DIM RainThisStep        AS SINGLE
DIM RainLastStep        AS SINGLE
DIM TotalPrecip         AS SINGLE
DIM Precip              AS SINGLE
DIM ActualPrecip        AS SINGLE


StartofMakeDimRainFall:

'IF disttype <> 4 THEN
'        CreateRainFile r
'ELSE
'        r.RainTimeStep = 30
'        r.RainDuration = 24
'        r.NumRainSteps = r.RainDuration * 60 / r.RainTimeStep + .5
'END IF

RainLastStep = 0
'LOCATE 2, 2
RainLastStep = 0
TotalPrecip = 0
FOR i = 1 TO r.NumberSteps
      DimTime = i / r.NumberSteps
      SELECT CASE r.Type
         CASE SCSTYPEII_RAINFALL
                IF DimTime <= 1 THEN Precip = .0178 + 1.893 * DimTime - .9192 * DimTime ^ 2
                IF DimTime = .5 THEN Precip = .663
                IF DimTime < .5 THEN Precip = 22.394 - 101.8 * DimTime + 116.5 * DimTime ^ 2
                IF DimTime < .44 THEN Precip = .4395 * DimTime ^ 1.195
                IF DimTime < .0271 THEN Precip = .226 * DimTime
        
         CASE SCSTYPEIIFL_RAINFALL
                IF DimTime <= 1 THEN Precip = -.0508 + 2.0277 * DimTime - .9855 * DimTime ^ 2
                IF DimTime = .5 THEN Precip = .607
                IF DimTime < .5 THEN Precip = .00953 + .0726 * DimTime + .9643 * DimTime ^ 2
                IF DimTime < .0271 THEN Precip = .226 * DimTime
        
         CASE SCSTYPEIII_RAINFALL
                IF DimTime <= 1 THEN Precip = 1.003 * DimTime ^ .2657
                IF DimTime < .7 THEN Precip = -3.8077 + 13.7517 * DimTime - 10.009 * DimTime ^ 2
                IF DimTime = .5 THEN Precip = .5
                IF DimTime <= .5 THEN Precip = .01 * EXP(7.212 * DimTime)
                IF DimTime < .0271 THEN Precip = .224 * DimTime
        
        'IF disttype = 4 THEN
        '        SELECT CASE i
        '                CASE 1: Precip = .0013: CASE 2: Precip = .0027: CASE 3: Precip = .004
        '                CASE 4: Precip = .008: CASE 5: Precip = .013: CASE 6: Precip = .021
        '                CASE 7: Precip = .034: CASE 8: Precip = .049: CASE 9: Precip = .07
        '                CASE 10: Precip = .091: CASE 11: Precip = .113: CASE 12: Precip = .136
        '                CASE 13: Precip = .183: CASE 14: Precip = .236: CASE 15: Precip = .304
        '                CASE 16: Precip = .386: CASE 17: Precip = .49: CASE 18: Precip = .593
        '                CASE 19: Precip = .666: CASE 20: Precip = .736: CASE 21: Precip = .772
        '                CASE 22: Precip = .809: CASE 23: Precip = .832: CASE 24: Precip = .854
        '                CASE 25: Precip = .876: CASE 26: Precip = .898: CASE 27: Precip = .913
        '                CASE 28: Precip = .927: CASE 29: Precip = .933: CASE 30: Precip = .939
        '                CASE 31: Precip = .944: CASE 32: Precip = .949: CASE 33: Precip = .953
        '                CASE 34: Precip = .958: CASE 35: Precip = .963: CASE 36: Precip = .968
        '                CASE 37: Precip = .972: CASE 38: Precip = .976: CASE 39: Precip = .979
        '                CASE 40: Precip = .983: CASE 41: Precip = .985: CASE 42: Precip = .988
        '                CASE 43: Precip = .99: CASE 44: Precip = .993: CASE 45: Precip = .9955
        '                CASE 46: Precip = .998: CASE 47: Precip = .999: CASE 48: Precip = 1!
        '        END SELECT
        'END IF
      END SELECT
      RainThisStep = Precip * r.Total
      r.Rain(i) = (RainThisStep - RainLastStep)
      IF r.Rain(i) < .001 THEN r.Rain(i) = .001
      r.Rain(i) = INT(r.Rain(i) * 1000 + .5) / 1000
      TotalPrecip = TotalPrecip + r.Rain(i)
      RainLastStep = RainThisStep
NEXT i

ActualPrecip = 0
PeakPrecip = 0
FOR i = 1 TO r.NumberSteps
     IF r.Rain(i) < 0 THEN r.Rain(i) = 0
     r.Rain(i) = r.Rain(i) * r.Total / TotalPrecip
     r.Rain(i) = INT(r.Rain(i) * 1000 + .5) / 1000
     ActualPrecip = ActualPrecip + r.Rain(i)
     IF r.Rain(i) > PeakPrecip THEN
        PeakPrecip = r.Rain(i)
        peakstep = i
     END IF
NEXT i

r.Rain(peakstep) = r.Rain(peakstep) + (r.Total - ActualPrecip)
r.Rain(peakstep) = INT(r.Rain(peakstep) * 1000 + .5) / 1000
END SUB

DEFSNG A-Y
SUB NewRainfall (TR AS RainfallType)
DIM i   AS INTEGER
TR.FileName = "NONE"
TR.Total = 0
TR.NumberSteps = 0
TR.Duration = 0
TR.TimeStep = 0
FOR i = 1 TO MAXSTEPS
    TR.Rain(i) = 0
NEXT i
END SUB

FUNCTION OpenRainFile% (TR AS RainfallType)
DIM i           AS INTEGER

IF TR.FileName = "" THEN
   OpenRainFile% = FALSE
END IF
TR.Total = 0

INPUT #1, TR.NumberSteps, TR.Duration, TR.TimeStep
FOR i = 1 TO TR.NumberSteps
       INPUT #1, TR.Rain(i)
       TR.Total = TR.Total + TR.Rain(i)
NEXT i

OpenRainFile% = TRUE
END FUNCTION

SUB RoundRainfall (places AS INTEGER, TR AS RainfallType)

TR.Total = 0
FOR i = 1 TO TR.NumberSteps
   TR.Total = TR.Total + TR.Rain(i)
   TR.Total = INT(TR.Total * 10 ^ places + .5) / 10 ^ places
NEXT i

END SUB

DEFINT A-Z
FUNCTION SaveRainFile% (TR AS RainfallType)

IF TR.TimeStep = 0 THEN
        SaveRainFile% = FALSE
        EXIT FUNCTION
END IF


PRINT #1, TR.NumberSteps, TR.Duration, TR.TimeStep
FOR i = 1 TO TR.NumberSteps
     PRINT #1, TR.Rain(i)
NEXT i

SaveRainFile% = TRUE
END FUNCTION

DEFSNG Z
SUB ScaleRainfall (r AS RainfallType)
DIM TotalPrecip         AS SINGLE

RoundRainfall 3, r

IF r.Total = 0 THEN EXIT SUB
'a$ = "You may scale an existing rainfall file to represent another|"
'a$ = a$ + "total rainfall.|"
'a$ = a$ + "The existing total rainfall is " + STR$(r.TotalRain)
'a$ = a$ + " (in).| The entire rainfall will be scaled to represent the|"
'a$ = a$ + "new total while the shape will be preserved."
'dummy = Alert(4, a$, 10, 10, 18, 70, "Cancel", "Continue", "")
'IF dummy = 0 OR dummy = 1 THEN EXIT SUB

'TotalPrecip = VAL(GetLabel$("", "Input New Total Precipitation (in):"))
IF TotalPrecip = 0 THEN EXIT SUB

FOR i = 1 TO r.NumberSteps
        r.Rain(i) = r.Rain(i) * TotalPrecip / r.Total
        r.Rain(i) = INT(r.Rain(i) * 1000 + .5) / 1000
NEXT i
r.Total = 0
FOR i = 1 TO r.NumberSteps
   r.Total = r.Total + r.Rain(i)
NEXT i
IF r.Total <> TotalPrecip THEN
   r.Rain(r.NumberSteps) = r.Rain(r.NumberSteps) + (TotalPrecip - r.Total)
   r.Rain(r.NumberSteps) = INT(r.Rain(r.NumberSteps) * 1000 + .5) / 1000
END IF

END SUB

