DEFINT A-Y
SUB getweirdischarge (i, p AS pondtype)
DIM a$(5)

a$(1) = "60 degree V-Notch Weir"
a$(2) = "90 degree V-Notch Weir"
a$(3) = "Sharp Crested Rectangular Weir"
a$(4) = "Broad Crested Weir"
a$(5) = "Orifice"

weirtyp = GetAnswer(5, a$(), "Weir" + STR$(i) + ": Define Weir Type")
IF weirtyp = 0 THEN EXIT SUB
p.weirtype(i) = a$(weirtyp)
p.weirstage(i) = VAL(GetLabel$("", "Input stage of weir >" + STR$(p.stage(1))))

        SELECT CASE weirtyp
                CASE 1
                        Discoeff! = GetValue!(1.43, "Input Discharge Coefficient")
                        power! = 2.5
                        factor! = 1!
                        bse! = 0!
                CASE 2
                       Discoeff! = GetValue!(2.5, "Input Discharge Coefficient")
                        power! = 2.5
                        factor! = 1!
                        bse! = 0!
                CASE 3 TO 4
                        bse! = GetValue(1, "Input Base Length (ft)")
                        IF weirtyp = 3 THEN defdiscoeff! = 3.33 ELSE defdiscoeff! = 3.087
                        Discoeff! = GetValue!(defdiscoeff!, "Input Discharge Coefficient")
                        IF weirtyp = 3 THEN defendcon! = 2! ELSE defendcon! = 0!
                        endcon! = GetValue!(defendcon!, "Number of End Contractions")
                        factor! = -endcon! / 10!
                        power! = 1.5

                CASE 5
                        bse! = 0!
                        OrifCoeff! = GetValue!(.6, "Input Orifice Coefficient")
                        area! = GetValue!(0, "Input orifice area (ft^2)")
                        Discoeff! = OrifCoeff! * area!
                        factor! = 0!
                        power! = 1.5

                END SELECT

                FOR j = 1 TO p.numstordisrel
                        height! = p.stage(j) - p.weirstage(i)
                        IF height! > 0 THEN
                                IF weirtyp = 5 THEN height! = 2 * 32.2 * height!
                                p.discharge(j) = p.discharge(j) + Discoeff! * (bse! + factor! * height!) ^ power!
                                IF p.discharge(j) < p.discharge(j - 1) THEN
                                        p.discharge(j) = p.discharge(j - 1) + ABS(p.discharge(j) - p.discharge(j - 1))
                                END IF
                        END IF
                NEXT j
END SUB
