DECLARE SUB PrintOrderForm (B$)


DEFINT A-Z
' ===========================================================================
'
' EXF3 - Exfiltration Program Copyright 1992, Ron Eaglin
'
' ===========================================================================
' ===========================================================================
' Decls, includes, and dimensions
' ===========================================================================
DECLARE SUB calcexfil ()
DECLARE FUNCTION setupoutput% ()

DECLARE FUNCTION getcfs# (volume#, x#, y#, z#)
DECLARE SUB designexfiltration ()
DECLARE SUB gethelp (help$)
DECLARE SUB getab (region%, eff#)
DECLARE SUB colordisplay ()
DECLARE SUB DemoFileNameListBox ()
DECLARE SUB MonoDisplay ()
DECLARE SUB SetupDesktop ()
DECLARE SUB SetupMenu ()
DECLARE SUB editexfiltration ()

DECLARE FUNCTION GetSaveFileName$ (a%)
DECLARE FUNCTION GetFileCount% (FileSpec$)
DECLARE FUNCTION FileRetrieve$ (FileSpec$)
DECLARE FUNCTION ControlEditWindow% (EditFields%, ButtonLine%, help$)

TYPE costdatatype
        numberdiameters         AS INTEGER
        diameter(10)             AS SINGLE
        NumberRocks(10)          AS INTEGER
        rockthickness(10, 3)     AS SINGLE
        costperfoot(10, 3)       AS SINGLE
        numberdepths(10, 3)      AS INTEGER
        depth(10, 3, 8)          AS SINGLE
        price(10, 3, 8)          AS SINGLE
END TYPE

' Declarations of cost data manipulations

DECLARE SUB printexfil (cost AS costdatatype)
DECLARE FUNCTION EditCostFile% (cost AS costdatatype)
DECLARE SUB SaveCostFile (cost AS costdatatype)
DECLARE SUB retrievecostfile (cost AS costdatatype)
DECLARE SUB calculatecosts (cost AS costdatatype, CostArray() AS SINGLE)
DECLARE SUB PrintCostData (cost AS costdatatype)

'$INCLUDE: 'stack.bi'

COMMON SHARED /uitools/ GloMenu           AS MenuMiscType
COMMON SHARED /uitools/ GloTitle()        AS MenuTitleType
COMMON SHARED /uitools/ GloItem()         AS MenuItemType
COMMON SHARED /uitools/ GloWindow()       AS windowType
COMMON SHARED /uitools/ GloButton()       AS buttonType
COMMON SHARED /uitools/ GloEdit()         AS EditFieldType
COMMON SHARED /uitools/ GloStorage        AS WindowStorageType
COMMON SHARED /uitools/ GloWindowStack()  AS INTEGER
COMMON SHARED /uitools/ GloBuffer$()

DIM GloTitle(MAXMENU)           AS MenuTitleType
DIM GloItem(MAXMENU, MAXITEM)   AS MenuItemType
DIM GloWindow(MAXWINDOW)        AS windowType
DIM GloButton(MAXBUTTON)        AS buttonType
DIM GloEdit(MAXEDITFIELD)       AS EditFieldType
DIM GloWindowStack(MAXWINDOW)   AS INTEGER
DIM GloBuffer$(MAXWINDOW + 1, 2)

DIM SHARED pickregion$(100)
DIM SHARED DisplayType          AS INTEGER
DIM SHARED area                 AS SINGLE
DIM cost                        AS costdatatype

DIM SHARED NumLandUses

DIM SHARED ExfilEff$(7)
DIM SHARED siteflag             AS INTEGER
DIM SHARED powera               AS SINGLE
DIM SHARED powerb               AS SINGLE
DIM SHARED totaltime            AS SINGLE
DIM SHARED totalVolume          AS SINGLE
DIM SHARED AverageOutflow       AS SINGLE
DIM SHARED TotalArea            AS SINGLE
DIM SHARED RainTimeStep         AS SINGLE
DIM SHARED HydroSteps           AS SINGLE
DIM SHARED region               AS INTEGER
DIM SHARED site
DIM SHARED effe                 AS INTEGER
DIM SHARED RunoffCoeff          AS DOUBLE
DIM SHARED LimExfRate           AS DOUBLE
DIM SHARED soilcover            AS DOUBLE
DIM SHARED DepthToGWT           AS DOUBLE
DIM SHARED volume(20)           AS DOUBLE
DIM SHARED CalcVolume(20)       AS DOUBLE
DIM SHARED Dia(20)              AS DOUBLE
DIM SHARED RockTh(20)           AS DOUBLE
DIM SHARED UnitArea(20)         AS DOUBLE
DIM SHARED UnitVolume(20)       AS DOUBLE
DIM SHARED FABRICAREA(20)       AS DOUBLE
DIM SHARED trenchlength(20)     AS DOUBLE
DIM SHARED EffecArea            AS DOUBLE
DIM SHARED Porosity             AS DOUBLE
DIM SHARED Pi                   AS SINGLE
DIM SHARED help$

    ' =======================================================================

    help$ = CURDIR$ + "\exhelp.hlp"

    ' =======================================================================
    ' Initialize Demo
    ' =======================================================================

    MenuInit
    WindowInit
    MouseShow
    colordisplay
ON ERROR GOTO errorhandler

    ' =======================================================================
    ' Show Opening alert window
    ' =======================================================================
    retrievecostfile cost
         
    a$ = "Exfiltration System Design Aid|"
    a$ = a$ + "|"

    a$ = a$ + "Copyright (c) 1992| Ron Eaglin, Marc Gauthier, & Marty Wanielista|"

    x = Alert(4, a$, 9, 10, 15, 70, "", "", "")



    ' =======================================================================
    ' Main Loop : Stay in loop until DemoFinished set to TRUE
    ' =======================================================================
mainloop:
    DemoFinished = FALSE

    WHILE NOT DemoFinished

        kbd$ = MenuInkey$
        WHILE MenuCheck(2)
            GOSUB MenuTrap
        WEND
    WEND

    ' =======================================================================
    ' End Program
    ' =======================================================================

    MouseHide
    COLOR 15, 0
    CLS
    END



' ===========================================================================
' If a menu event occured, call the proper demo, or if Exit, set demoFinished
' ===========================================================================

MenuTrap:
    menu = MenuCheck(0)
    item = MenuCheck(1)
   
    SELECT CASE menu
        CASE 1
            SELECT CASE item
                CASE 1: gethelp help$
                CASE 2: LPRINT CHR$(12)
                CASE 3:
                CASE 4: DemoFinished = TRUE
            END SELECT
        CASE 2
            SELECT CASE item
                CASE 1: designexfiltration
                        printexfil cost
                CASE 2: editexfiltration
                CASE 3: printexfil cost
            END SELECT
        CASE 3
            SELECT CASE item
                CASE 1: j = EditCostFile(cost)
                CASE 2: SaveCostFile cost
                CASE 3: PrintCostData cost
            END SELECT
        CASE 4
             SELECT CASE item
                CASE 1: PrintOrderForm "order.frm"
                CASE 2: PrintOrderForm "about.frm"
              END SELECT
        CASE ELSE
    END SELECT
RETURN

errorhandler:
    a$ = a$ + "An Error " + STR$(ERR) + "occurred"
    x = Alert(4, a$, 9, 10, 15, 70, "", "", "")
    RESUME mainloop
END

SUB calcexfil
Pi = 3.14159

FOR i = 1 TO 20
        volume(i) = 0
        CalcVolume(i) = 0
        trenchlength(i) = 0
NEXT i

OPEN "Pipedia.dat" FOR INPUT AS #1
  FOR i = 1 TO 20
    INPUT #1, Dia(i), RockTh(i)
    Dia(i) = Dia(i) / 12
    RockTh(i) = RockTh(i) / 12
    L1# = Dia(i) / 2 + .33 * RockTh(i)
    L2# = Dia(i) / 2 + RockTh(i)
    L3# = (L2# ^ 2 - L1# ^ 2) ^ .5
    Beta# = Pi - ATN(L3# / L1#)
    UnitArea(i) = 2 * Beta# * L2#
    UnitVolume(i) = (Beta# * L2# ^ 2 + L1# * L3#) * Porosity + (Pi * (Dia(i) / 2) ^ 2) * (1 - Porosity)
  NEXT i
CLOSE #1

OPEN "exfil.dat" FOR INPUT AS #1
DO
        INPUT #1, reg$
        IF reg$ = pickregion$(region) THEN EXIT DO
        FOR i = 1 TO 7
        INPUT #1, effetest, a#, B#, c#
        NEXT i
LOOP WHILE NOT EOF(1)

DO
        INPUT #1, effetest, a#, B#, c#
LOOP WHILE effe <> effetest AND NOT EOF(1)

CLOSE #1



FOR i = 1 TO 20
Pi = 3.14159
H# = Dia(i) + 1.33 * RockTh(i)
Depth1# = soilcover + H# - DepthToGWT
R1# = Dia(i) / 2 + RockTh(i)
        
        IF DepthToGWT < H# + soilcover THEN

             IF R1# > Depth1# THEN
                Depth2# = R1# - Depth1#
                IF Depth2# = 0 THEN Depth2# = .00001
                pHI1# = ATN((R1# ^ 2! - Depth2# ^ 2!) ^ .5 / Depth2#)
                WETAREA# = 2! * R1# * pHI1#
                     IF Depth1# <= RockTh(i) THEN

                       REM gwt above trench invert but below pipe invert (CASE II)
                        WETVOL# = Porosity * ((pHI1# * (R1# ^ 2!)) - ((R1# ^ 2! - Depth2# ^ 2!) ^ .5) * Depth2#)
                       
                     ELSE

                       REM gwt above pipe invert but below center line of pipe (CASE III)
                       
                        dummy# = ABS((Dia(i) / 2!) ^ 2! - Depth2# ^ 2!) ^ .5
                        IF Depth2# = 0 THEN Depth2# = .00001
                        Phi2# = ATN(dummy# / Depth2#)
                      wdummy# = Porosity * (pHI1# * R1# ^ 2! - ABS(R1# ^ 2! - Depth2# ^ 2!) ^ .5 * Depth2#)
                        WETVOL# = wdummy# + (1 - Porosity) * (Phi2# * (Dia(i) / 2!) ^ 2! - dummy# * Depth2#)
                     END IF
             ELSE
                Depth2# = Depth1# - R1#
                     IF Depth1# >= H# THEN

                       REM gwt above top of trench...trench submerged (CASE VI)
                        
                        WETAREA# = UnitArea(i) - (1E-15)
                        WETVOL# = UnitVolume(i) - (1E-15)
                     ELSE
                        dummy# = ABS(R1# ^ 2! - Depth2# ^ 2!) ^ .5
                        Theta1# = ATN(dummy# / Depth2#)
                        pHI1# = Pi - Theta1#
                        WETAREA# = 2! * pHI1# * R1#
                             IF Depth2# < (Dia(i) / 2!) THEN
                               REM gwt above pipe center line but below top of pipe (CASE IV)
                        
                                dummy# = ABS((Dia(i) / 2!) ^ 2! - Depth2# ^ 2!) ^ .5
                                IF Depth2# = 0 THEN Depth2# = .00001
                                Theta2# = ATN(dummy# / Depth2#)
                                Phi2# = Pi - Theta2#
                                wdummy# = Porosity * pHI1# * R1# ^ 2! + ABS(R1# ^ 2! - Depth2# ^ 2) ^ .5 * Depth2#
                                WETVOL# = wdummy# + (1 - Porosity) * (Phi2# * (Dia(i) / 2) ^ 2 + ABS((Dia(i) / 2) ^ 2! - Depth2# ^ 2!) ^ .5 * Depth2#)
                             ELSE
                               REM gwt above top of pipe but below top of trench (CASE V)
                        

                                WETVOL# = Porosity * (pHI1# * R1# ^ 2 + (R1# ^ 2 - Depth2# ^ 2) ^ .5 * Depth2#) + (1 - Porosity) * (Pi * ((Dia(i)) / 2) ^ 2)
                             END IF
                     END IF
                END IF
     ELSE
        WETAREA# = 0
        WETVOL# = 0

     END IF
     UnitArea(i) = UnitArea(i) - WETAREA#
    UnitVolume(i) = UnitVolume(i) - WETVOL#
     volume(i) = .5
     count# = 0
     WHILE (ABS((CalcVolume(i) - volume(i))) / volume(i) > .01 AND count# < 200)
       count# = count# + 1
             cfs# = getcfs#(volume(i), a#, B#, c#)
        FABRICAREA(i) = 43200 * cfs# / LimExfRate
        trenchlength(i) = FABRICAREA(i) / UnitArea(i)
        CalcVolume(i) = .000275 * trenchlength(i) * UnitVolume(i)
        volume(i) = (volume(i) + CalcVolume(i)) / 2
             IF volume(i) < .2 THEN volume(i) = .2
             IF volume(i) > 2 THEN volume(i) = 2
     
    WEND
     EffecArea = TotalArea * RunoffCoeff
     trenchlength(i) = INT(trenchlength(i) * EffecArea)
 NEXT i
colordisplay
END SUB

SUB calculatecosts (cost AS costdatatype, CostArray() AS SINGLE)
l = 1
FOR i = 1 TO cost.numberdiameters
        effdepth! = soilcover + cost.diameter(i) / 12

        FOR j = 1 TO cost.NumberRocks(i)
                k = 1
                WHILE effdepth! > cost.depth(i, j, k) AND k <= cost.numberdepths(i, j): k = k + 1: WEND
                IF k > 1 AND k <= cost.numberdepths(i, j) THEN
                        costpoint = k - 1
                        costfactor! = (effdepth! - cost.depth(i, j, k - 1)) / (cost.depth(i, j, k) - cost.depth(i, j, k - 1))
                ELSEIF k = 1 THEN
                        costpoint = 1
                        costfactor = 1!
                ELSEIF k > cost.numberdepths(i, j) THEN
                        costpoint = cost.numberdepths(i, j)
                        costfactor! = (effdepth! - cost.depth(i, j, k - 1)) / (cost.depth(i, j, k) - cost.depth(i, j, k - 1))
                END IF

                CostArray(l) = trenchlength(l) * cost.costperfoot(i, j)
                CostArray(l) = CostArray(l) + (cost.price(i, j, costpoint) + costfactor! * (cost.price(i, j, costpoint) - cost.price(i, j, costpoint - 1))) * trenchlength(l)
                l = l + 1
        NEXT j
NEXT i


END SUB

SUB colordisplay
    DisplayType = TRUE
    MouseHide
    SetupMenu
    SetupDesktop
    MenuShow
    MouseShow
END SUB

SUB DemoFileNameListBox
    
    WindowOpen 1, 8, 20, 15, 60, 0, 7, 0, 7, 15, FALSE, FALSE, FALSE, TRUE, 1, ""

    WindowLocate 2, 4
    Windowprint 4, "Enter a file specification:"
    WindowBox 3, 4, 5, 38

    EditFieldOpen 1, "*.*", 4, 5, 0, 0, 23, 22
    WindowLine 7
    ButtonOpen 1, 2, "OK", 8, 17, 0, 0, 1

    ' =======================================================================
    ' Set initial state + go into main loop
    ' =======================================================================

    currButton = 0
    currEditField = 1
   
    ExitFlag = FALSE
    WHILE NOT ExitFlag
        WindowDo currButton, currEditField
        SELECT CASE Dialog(0)
            CASE 1, 6                       'Button, or Enter, exit loop
                ExitFlag = TRUE
            CASE 2                          'EditField, switch to edit field
                currButton = 0
                currEditField = 1
            CASE 7, 8                       'tab and backTab, flip/flop state
                IF currButton = 1 THEN
                    currButton = 0
                    currEditField = 1
                ELSE
                    currButton = 1
                    currEditField = 0
                END IF
            CASE 9                          'escape
                Windowclose 1
                EXIT SUB
            CASE 14                         'space - if on button then exit
                IF currButton = 1 THEN
                    ExitFlag = TRUE
                END IF
            CASE ELSE
        END SELECT
    WEND

    ' =======================================================================
    ' Assign the variable before closing the window, and close the window
    ' =======================================================================

    FileSpec$ = EditFieldInquire$(1)

    ' =======================================================================
    ' Make sure its a valid file name
    ' =======================================================================

    delimit = INSTR(FileSpec$, ".")

    IF delimit THEN
        filename$ = LEFT$(FileSpec$, delimit - 1)
        fileExt$ = RIGHT$(FileSpec$, LEN(FileSpec$) - (delimit))
    ELSE
        filename$ = FileSpec$
        fileExt$ = ""
    END IF

    IF LEN(FileSpec$) = 0 OR LEN(filename$) > 8 OR LEN(fileExt$) > 3 THEN
        Windowclose 1
        junk = Alert(4, "You didn't enter a valid file specification.", 10, 15, 12, 62, "OK", "", "")
        EXIT SUB
    END IF

    FileCount = GetFileCount(FileSpec$)

    IF FileCount THEN

        REDIM FileList$(FileCount)

    ELSE

        Windowclose 1
        junk = Alert(4, "No match to your file specification could be found.", 10, 10, 12, 70, "OK", "", "")
        EXIT SUB
    END IF
   
    FileList$(1) = DIR$(FileSpec$)
   
    FOR Indx = 2 TO FileCount
        FileList$(Indx) = DIR$
    NEXT Indx
   
    x = ListBox(FileList$(), UBOUND(FileList$))

    SELECT CASE x
        CASE 0
            junk = Alert(4, "You selected CANCEL", 10, 25, 12, 55, "OK", "", "")
        CASE ELSE
            junk = Alert(4, "You selected " + FileList$(x), 10, 25, 12, 55, "OK", "", "")
    END SELECT

    Windowclose 1
END SUB

SUB designexfiltration

IF soilcover = 0 THEN
        editexfiltration
        IF region = 0 OR effe = 0 THEN EXIT SUB
END IF
calcexfil

END SUB

FUNCTION EditCostFile (cost AS costdatatype)
DIM a$(15)

FOR i = 1 TO cost.numberdiameters
        a$(i) = STR$(cost.diameter(i))
NEXT i
pipetoedit = MultAnswer(cost.numberdiameters, a$(), "Choose Pipe to Edit")
IF pipetoedit = 0 THEN EditCostFile = FALSE: EXIT FUNCTION

FOR i = 1 TO cost.NumberRocks(pipetoedit)
        a$(i) = STR$(cost.rockthickness(pipetoedit, i))
NEXT i
rocktoedit = MultAnswer(cost.NumberRocks(pipetoedit), a$(), "Choose Rock Thickness")
IF rocktoedit = 0 THEN EditCostFile = FALSE: EXIT FUNCTION

WindowOpen 1, 4, 5, 9 + cost.numberdepths(pipetoedit, rocktoedit), 75, 0, 7, 0, 7, 15, FALSE, FALSE, FALSE, TRUE, 1, "COST DATA EDIT"
WindowLocate 1, 5
Windowprint -1, "Pipe diameter (in)   Rock Thickness (in)     Total Cost  ($/ft)"
EditFieldOpen 1, STR$(cost.diameter(pipetoedit)), 2, 15, 14, 1, 6, 6
EditFieldOpen 2, STR$(cost.rockthickness(pipetoedit, rocktoedit)), 2, 30, 14, 1, 6, 6
EditFieldOpen 3, STR$(cost.costperfoot(pipetoedit, rocktoedit)), 2, 55, 14, 1, 8, 8
WindowLine 3
WindowLocate 4, 10
Windowprint -1, "Depth of excavation ft    Cost of exacavation $/linear foot"

FOR i = 1 TO cost.numberdepths(pipetoedit, rocktoedit)
        WindowLocate 3 + i, 6
        EditFieldOpen i + 3, STR$(cost.depth(pipetoedit, rocktoedit, i)), i + 4, 15, 14, 1, 10, 10
        EditFieldOpen i + 3 + cost.numberdepths(pipetoedit, rocktoedit), STR$(cost.price(pipetoedit, rocktoedit, i)), i + 4, 40, 14, 1, 10, 10
NEXT i
WindowLine i + 4

flag = ControlEditWindow(2 * cost.numberdepths(pipetoedit, rocktoedit) + 3, cost.numberdepths(pipetoedit, rocktoedit) + 6, help$)
IF flag = FALSE THEN EditCostFile = FALSE: EXIT FUNCTION

cost.diameter(pipetoedit) = VAL(EditFieldInquire(1))
cost.costperfoot(pipetoedit, rocktoedit) = VAL(EditFieldInquire(2))
cost.costperfoot(pipetoedit, rocktoedit) = VAL(EditFieldInquire(3))
FOR i = 1 TO cost.numberdepths(pipetoedit, rocktoedit)
        cost.depth(pipetoedit, rocktoedit, i) = VAL(EditFieldInquire(i + 3))
        cost.price(pipetoedit, rocktoedit, i) = VAL(EditFieldInquire(i + 3 + cost.numberdepths(pipetoedit, rocktoedit)))
NEXT i

Windowclose 1
EditCostFile = TRUE
END FUNCTION

SUB editexfiltration
DIM a$(50)
k = 1
OPEN "exfil.dat" FOR INPUT AS #1
DO
        IF EOF(1) THEN EXIT DO

        INPUT #1, pickregion$(k)
        IF EOF(1) THEN EXIT DO
        FOR i = 1 TO 7

        INPUT #1, effetest, a#, B#, c#
        NEXT i
        k = k + 1
LOOP WHILE NOT EOF(1)
k = k - 1
CLOSE #1

region = MultAnswer(k, pickregion$(), "Choose Region")
IF region = 0 THEN EXIT SUB

ExfilEff$(1) = "95 %"
ExfilEff$(2) = "90 %"
ExfilEff$(3) = "85 %"
ExfilEff$(4) = "80 %"
ExfilEff$(5) = "70 %"
ExfilEff$(6) = "60 %"
ExfilEff$(7) = "50 %"


effe = GetAnswer(7, ExfilEff$(), "Choose Diversion Efficiency")
IF effe = 0 THEN EXIT SUB
WindowOpen 1, 5, 10, 14, 70, 0, 7, 0, 7, 14, FALSE, FALSE, FALSE, TRUE, 2, "EXFILTRATION"
WindowLocate 2, 2
Windowprint -1, "Watershed Area (acres)"
WindowLocate 3, 2
Windowprint -1, "Runoff Coefficient (0 to 1)"
WindowLocate 4, 2
Windowprint -1, "Limiting Exfiltration Rate (in/hour)"
WindowLocate 5, 2
Windowprint -1, "Depth to Seasonal High Water Table (ft)"
WindowLocate 6, 2
Windowprint -1, "Required Soil Cover (ft)"
WindowLocate 7, 2
Windowprint -1, "Rock Porosity, n"
WindowLocate 8, 2
Windowprint -1, "Region"
WindowLocate 8, 48
Windowprint -1, pickregion$(region)
WindowLocate 9, 2
Windowprint -1, "Diversion Efficiency"
WindowLocate 9, 48
Windowprint -1, ExfilEff$(effe)

IF TotalArea > 0 THEN a$(1) = STR$(TotalArea) ELSE a$(1) = ""
IF RunoffCoeff > 0 THEN a$(2) = STR$(RunoffCoeff) ELSE a$(2) = ""
IF LimExfRate > 0 THEN a$(3) = STR$(LimExfRate) ELSE a$(3) = ""
IF DepthToGWT > 0 THEN a$(4) = STR$(DepthToGWT) ELSE a$(4) = ""
IF soilcover > 0 THEN a$(5) = STR$(soilcover) ELSE a$(5) = ""
IF Porosity > 0 THEN a$(6) = STR$(Porosity) ELSE a$(6) = ""

EditFieldOpen 1, a$(1), 2, 48, 14, 1, 8, 5
EditFieldOpen 2, a$(2), 3, 48, 14, 1, 8, 5
EditFieldOpen 3, a$(3), 4, 48, 14, 1, 8, 5
EditFieldOpen 4, a$(4), 5, 48, 14, 1, 8, 5
EditFieldOpen 5, a$(5), 6, 48, 14, 1, 8, 5
EditFieldOpen 6, a$(6), 7, 48, 14, 1, 8, 5

IF ControlEditWindow(6, 10, help$) = FALSE THEN EXIT SUB

TotalArea = VAL(EditFieldInquire(1))
RunoffCoeff = VAL(EditFieldInquire(2))
LimExfRate = VAL(EditFieldInquire(3))
DepthToGWT = VAL(EditFieldInquire(4))
soilcover = VAL(EditFieldInquire(5))
Porosity = VAL(EditFieldInquire(6))

Windowclose 1
IF RunoffCoeff < 0 OR RunoffCoeff > 1 THEN
        a$ = "WARNING !!!|"
        a$ = a$ + "Runoff coefficient is not within defined range.|"
        a$ = a$ + "Range is between 0 and 1|"
        junk = Alert(4, a$, 6, 10, 12, 70, "", "", "")
END IF

IF LimExfRate < .5 OR LimExfRate > 5 THEN
        a$ = "WARNING !!!|"
        a$ = a$ + "Limiting exfiltration rate is typically|"
        a$ = a$ + "between .5 and 5 inches per hour.|"
        junk = Alert(4, a$, 6, 10, 12, 70, "", "", "")
END IF

IF DepthToGWT <= soilcover THEN
        a$ = "WARNING !!!|"
        a$ = a$ + "Trench lies completely under ground water table.|"
        a$ = a$ + "There is no storage within trench and|"
        a$ = a$ + "system will not operate."
        junk = Alert(4, a$, 6, 10, 12, 70, "", "", "")
END IF

END SUB

DEFSNG A-Z
FUNCTION FileRetrieve$ (FileSpec$)
DEFINT A-Y

        delimit = INSTR(FileSpec$, ".")

    IF delimit THEN
        filename$ = LEFT$(FileSpec$, delimit - 1)
        fileExt$ = RIGHT$(FileSpec$, LEN(FileSpec$) - (delimit))
    ELSE
        filename$ = FileSpec$
        fileExt$ = ""
    END IF

    IF LEN(FileSpec$) = 0 OR LEN(filename$) > 8 OR LEN(fileExt$) > 3 THEN
        EXIT FUNCTION
    END IF

    FileCount = GetFileCount(FileSpec$)

    IF FileCount THEN

        REDIM FileList$(FileCount)

    ELSE

        junk = Alert(4, "No match to your file specification could be found.", 10, 10, 12, 70, "OK", "", "")
        EXIT FUNCTION
    END IF

    FileList$(1) = DIR$(FileSpec$)

    FOR Indx = 2 TO FileCount
        FileList$(Indx) = DIR$
    NEXT Indx

    x = ListBox(FileList$(), UBOUND(FileList$))

    SELECT CASE x
        CASE 0
            junk = Alert(4, "You selected CANCEL", 10, 25, 12, 55, "OK", "", "")
            FileList$(x) = ""
        CASE ELSE
            junk = Alert(4, "You selected " + FileList$(x), 10, 25, 12, 55, "OK", "", "")
    END SELECT
    FileRetrieve$ = FileList$(x)
    Windowclose 1
END FUNCTION

DEFSNG A-Y
SUB getab (region%, eff#)

OPEN "reuse.dat" FOR INPUT AS #1
FOR i = 1 TO region% - 1
        INPUT #1, a$
        INPUT #1, junk
        FOR j = 1 TO 6
                INPUT #1, junk, junk
        NEXT j
NEXT i
INPUT #1, a$
INPUT #1, junk
FOR i = 1 TO eff# - 1
        INPUT #1, junk, junk
NEXT i
INPUT #1, powera, powerb
CLOSE #1
END SUB

DEFINT A-Z
FUNCTION getcfs# (volume#, x#, y#, z#)
        IF volume# <> 0 THEN getcfs# = x# + y# * EXP(z# * volume#)
END FUNCTION

FUNCTION GetFileCount (FileSpec$)
    count = 0
    filename$ = DIR$(FileSpec$)
    DO WHILE filename$ <> ""
        count = count + 1
        filename$ = DIR$
    LOOP
    GetFileCount = count
END FUNCTION

FUNCTION GetSaveFileName$ (a)

    WindowOpen 2, 8, 20, 15, 60, 0, 7, 0, 7, 15, FALSE, FALSE, FALSE, TRUE, 1, ""

    WindowLocate 2, 4
    Windowprint 4, "Enter a file name (no extension)"
    WindowBox 3, 4, 5, 38

    Direct$ = CURDIR$ + "\"
    EditFieldOpen 1, Direct$, 4, 5, 0, 0, 23, 22
    WindowLine 7
    ButtonOpen 1, 2, "OK", 8, 17, 0, 0, 1

    ' =======================================================================
    ' Set initial state + go into main loop
    ' =======================================================================

    currButton = 0
    currEditField = 1

    ExitFlag = FALSE
    WHILE NOT ExitFlag
        WindowDo currButton, currEditField
        SELECT CASE Dialog(0)
            CASE 1, 6                       'Button, or Enter, exit loop
                ExitFlag = TRUE
            CASE 2                          'EditField, switch to edit field
                currButton = 0
                currEditField = 1
            CASE 7, 8                       'tab and backTab, flip/flop state
                IF currButton = 1 THEN
                    currButton = 0
                    currEditField = 1
                ELSE
                    currButton = 1
                    currEditField = 0
                END IF
            CASE 9                          'escape
                Windowclose 2
                EXIT FUNCTION
            CASE 14                         'space - if on button then exit
                IF currButton = 1 THEN
                    ExitFlag = TRUE
                END IF
            CASE ELSE
        END SELECT
    WEND

    GetSaveFileName$ = EditFieldInquire(1)

    Windowclose 2
END FUNCTION

SUB PrintCostData (cost AS costdatatype)
a = setupoutput
IF a = 0 THEN EXIT SUB

a1$ = "       ROCK THICKNESS: ###   PIPE AND ROCK COST IN DOLLARS/FOOT: ####"
a2$ = "                  DIAMETER OF PIPE: ### INCHES"
FOR i = 1 TO cost.numberdiameters
        IF a = 1 THEN CLS
        FOR j = 1 TO cost.NumberRocks(i)
                PRINT #1,
                PRINT #1,
                PRINT #1, USING a2$; cost.diameter(i)
                PRINT #1, USING a1$; cost.rockthickness(i, j); cost.costperfoot(i, j)
                PRINT #1, "------------------------------------------------------------------------"
                FOR k = 1 TO cost.numberdepths(i, j)
                        PRINT #1, USING "       EXCAVATION DEPTH (FT): ## EXCAVATION COST $/FT: ###.##"; cost.depth(i, j, k); cost.price(i, j, k)
                NEXT k
        NEXT j
        IF a = 1 THEN WHILE INKEY$ = "": WEND
NEXT i
IF a = 2 THEN PRINT #1, CHR$(12)
colordisplay
CLOSE #1
END SUB

SUB printexfil (cost AS costdatatype)
DIM CostArray(22)       AS SINGLE

a = setupoutput
IF a = 0 THEN EXIT SUB
calculatecosts cost, CostArray()

PRINT #1,
PRINT #1,
PRINT #1, , "WATERSHED AREA:", TotalArea; "  ac."
PRINT #1, , "EFFECTIVE IMPER. AREA:", EffecArea; " ac."
PRINT #1, , "RUNOFF COEFFICIENT: ", RunoffCoeff
PRINT #1, , "LIMITING EXF. RATE:", LimExfRate; "  in/hr through fabric"
PRINT #1, , "DIVERSION EFFICIENCY:", ExfilEff$(effe)
PRINT #1, , "WATER TABLE DEPTH:", DepthToGWT; " ft."
PRINT #1, , "DEPTH OF COVER:", soilcover; " ft."
PRINT #1, , "POROSITY:", , Porosity
PRINT #1, , "REGION", , pickregion$(region)
PRINT #1,
PRINT #1, , "NOTE: Trench Volumes less than 0.2 inches or greater"
PRINT #1, , "      than 2 inches are outside the limits of the"
PRINT #1, , "      regression data and should not be used."
PRINT #1,
IF a = 1 THEN PRINT #1, TAB(20); "Hit any key to continue"
IF a = 1 THEN WHILE INKEY$ = "": WEND
PRINT #1, USING " DIAMETER  ROCK THICKNESS    TRENCH     TRENCH VOLUME, EIA = ##.## ACRES"; EffecArea
PRINT #1, "  (in)       (in)         LENGTH (ft)  IN. OVER EIA   ACRE-FEET     COST ($)"
PRINT #1,
FOR i = 1 TO 20
PRINT #1, USING "   ##       ###            ####          ##.##         #.####     ######.##"; 12 * Dia(i); 12 * RockTh(i); trenchlength(i); CalcVolume(i); CalcVolume(i) * EffecArea / 12; CostArray(i)

NEXT i
IF a = 2 THEN PRINT #1, CHR$(12)
IF a = 1 THEN WHILE INKEY$ = "": WEND
colordisplay
CLOSE #1
END SUB

SUB PrintOrderForm (B$)
a = setupoutput
IF a = 0 THEN EXIT SUB
IF a = 1 THEN CLS
OPEN B$ FOR INPUT AS #2
i = 1
WHILE NOT EOF(2)
        LINE INPUT #2, a$
        PRINT #1, a$
        i = i + 1
        IF i / 20! = INT(i / 20) AND a = 1 THEN WHILE INKEY$ = "": WEND
WEND
IF a = 1 THEN WHILE INKEY$ = "": WEND
IF a = 2 THEN PRINT #1, CHR$(12)
CLOSE #1
CLOSE #2
colordisplay
END SUB

SUB retrievecostfile (cost AS costdatatype)

OPEN ROOTDIR$ + "cost.dat" FOR INPUT AS #1
        INPUT #1, cost.numberdiameters
        FOR i = 1 TO cost.numberdiameters
                INPUT #1, cost.diameter(i)
                INPUT #1, cost.NumberRocks(i)
                FOR j = 1 TO cost.NumberRocks(i)
                        INPUT #1, cost.rockthickness(i, j), cost.costperfoot(i, j), cost.numberdepths(i, j)
                        FOR k = 1 TO cost.numberdepths(i, j)
                                INPUT #1, cost.depth(i, j, k), cost.price(i, j, k)
                        NEXT k
                NEXT j
        NEXT i
CLOSE #1
        
END SUB

SUB SaveCostFile (cost AS costdatatype)

OPEN ROOTDIR$ + "\cost.dat" FOR OUTPUT AS #1
        PRINT #1, cost.numberdiameters
        FOR i = 1 TO cost.numberdiameters
                PRINT #1, cost.diameter(i)
                PRINT #1, cost.NumberRocks(i)
                FOR j = 1 TO cost.NumberRocks(i)
                        PRINT #1, cost.rockthickness(i, j), cost.costperfoot(i, j), cost.numberdepths(i, j)
                        FOR k = 1 TO cost.numberdepths(i, j)
                                PRINT #1, cost.depth(i, j, k), cost.price(i, j, k)
                        NEXT k
                NEXT j
        NEXT i
CLOSE #1

END SUB

DEFSNG A-Z
SUB SetupDesktop STATIC

    MouseHide

    WIDTH , 25
 
    COLOR 15, 1      'Color
  
    CLS

    FOR a = 2 TO 80 STEP 4
        FOR B = 2 TO 25 STEP 2
            LOCATE B, a
            PRINT CHR$(250);
        NEXT B
    NEXT a

    MouseShow
END SUB

DEFINT A-Z
SUB SetupMenu

    MenuSet 1, 0, 1, "Utilities", 1
    MenuSet 1, 1, 1, "Online Help Function", 1
    MenuSet 1, 2, 1, "Send Form Feed to Printer", 1
    MenuSet 1, 3, 1, "-", 1
    MenuSet 1, 4, 1, "Exit             Ctrl-X", 2
                          

    MenuSet 2, 0, 1, "Exfiltration", 2
    MenuSet 2, 1, 1, "Design System", 1
    MenuSet 2, 2, 1, "Edit Design Parameters", 1
    MenuSet 2, 3, 1, "Print Current Design", 1

    MenuSet 3, 0, 1, "Cost", 1
    MenuSet 3, 1, 1, "Edit Cost Data", 1
    MenuSet 3, 2, 1, "Save Cost Data", 1
    MenuSet 3, 3, 1, "Print Cost Data", 1

    MenuSet 4, 0, 1, "Order", 1
    MenuSet 4, 1, 1, "Print Order Form", 7
    MenuSet 4, 2, 1, "Print About Form", 7

    ShortCutKeySet 1, 4, CHR$(24)          ' Ctrl-X

        MenuColor 0, 7, 4, 8, 15, 0, 12   'Best for color
    MenuPreProcess

END SUB

FUNCTION setupoutput
DIM a$(5)

a$(1) = "Screen"
a$(2) = "Printer"
a$(3) = "File"

a = GetAnswer(3, a$(), "Where would like data printed?")
IF a = 0 THEN EXIT FUNCTION
SELECT CASE a
        CASE 1
                OPEN "scrn:" FOR OUTPUT AS #1
                CLS
                LOCATE 3, 1
        CASE 2
                OPEN "lpt1:" FOR OUTPUT AS #1
        CASE 3
                filename$ = GetSaveFileName$(1) + ".prn"
                IF filename$ = ".prn" THEN EXIT FUNCTION
                OPEN filename$ FOR OUTPUT AS #1
END SELECT
setupoutput = a
END FUNCTION

