'$INCLUDE: 'smada.bi'

SUB NewShedFile (tw AS WatershedType)
tw.infmeth = 0

tw.FileName = "None"
tw.TotalArea = 0
tw.TimeCon = 0
tw.ImpArea = 0
tw.DCIA = 0
w.AddAbsImp = 0
tw.addabsPerv = 0
tw.MaxInf = 0
tw.HIC = 0
tw.HIO = 0
tw.HK = 0
    
tw.CN = 0
tw.InitAbs = 0
    


END SUB

DEFINT A-Z
FUNCTION OpenShedFile% (tw AS WatershedType)

IF tw.FileName = "" THEN
   OpenShedFile% = FALSE
END IF

INPUT #1, tw.TotalArea
INPUT #1, tw.TimeCon
INPUT #1, tw.ImpArea
INPUT #1, tw.DCIA
INPUT #1, tw.AddAbsImp
INPUT #1, tw.addabsPerv
INPUT #1, tw.MaxInf
INPUT #1, tw.infmeth

SELECT CASE tw.infmeth
    CASE HORTON_INFILTRATION
        INPUT #1, tw.HIC
        INPUT #1, tw.HIO
        INPUT #1, tw.HK
    CASE SCS_INFILTRATION
        INPUT #1, tw.CN
        INPUT #1, tw.InitAbs
END SELECT

IF tw.DCIA <> 0 THEN tw.FracDCIA = (tw.ImpArea / tw.TotalArea) * (tw.DCIA / 100)
IF tw.TotalArea <> 0 THEN
        tw.FracDCIA = (tw.DCIA / 100) * tw.ImpArea / tw.TotalArea
        tw.FracNDCIA = (tw.ImpArea / tw.TotalArea) * ((100 - tw.DCIA) / 100)
        tw.FracPerv = (tw.TotalArea - tw.ImpArea) / tw.TotalArea
END IF

OpenShedFile% = TRUE

END FUNCTION

DEFSNG A-Z
FUNCTION SaveShedFile% (tw AS WatershedType)

IF tw.infmeth = 0 THEN
        SaveShedFile% = FALSE
        EXIT FUNCTION
END IF

PRINT #1, tw.TotalArea
PRINT #1, tw.TimeCon
PRINT #1, tw.ImpArea
PRINT #1, tw.DCIA
PRINT #1, tw.AddAbsImp
PRINT #1, tw.addabsPerv
PRINT #1, tw.MaxInf
PRINT #1, tw.infmeth

SELECT CASE tw.infmeth
    CASE HORTON_INFILTRATION
        PRINT #1, tw.HIC
        PRINT #1, tw.HIO
        PRINT #1, tw.HK
    CASE SCS_INFILTRATION
        PRINT #1, tw.CN
        PRINT #1, tw.InitAbs
    END SELECT

SaveShedFile% = TRUE
END FUNCTION

